/*----------------------------------------------------------------------+
|                                                                       |
| Copyright , Bentley Systems, Incorporated,                    |
| All rights reserved.                                                  |
|                                                                       |
|                                                                       |
| Limited permission is hereby granted to reproduce and modify this     |
| copyrighted material provided that the resulting code is used only in |
| conjunction with Bentley Systems products under the terms of the      |
| license agreement provided therein, and that this notice is retained  |
| in its entirety in any such reproduction or modification.             |
|                                                                       |
+----------------------------------------------------------------------*/
/*----------------------------------------------------------------------+
|                                                                       |
|   $Workfile:   savedviewhelper  $
|   $Revision:  $
|       $Date:  $
|                                                                       |
+----------------------------------------------------------------------*/
/*----------------------------------------------------------------------+
|                                                                       |
|   savedviewhelper - savedviewhelper source code. |
|                                                                       |
+----------------------------------------------------------------------*/
/*----------------------------------------------------------------------+
|                                                                       |
|   Include Files                                                       |
|                                                                       |
+----------------------------------------------------------------------*/
#include    <mdl.h>
#include    <MicroStationAPI.h>
#include    <stdio.h>
#include    <string.h>
#include    <malloc.h>
#include    <mselemen.fdf>
#include    <mselmdsc.fdf>
#include    <mslinkge.fdf>
#include    <msscancrit.fdf>
#include    <mstagdat.fdf>
#include    <mselems.h>
#include    <mscell.fdf>
#include    <leveltable.fdf>
#include    <mslstyle.fdf>
#include    <msstrlst.h>
#include    <mscnv.fdf>
#include    <msdgnobj.fdf>
#include    <msmodel.fdf>
#include    <msview.fdf>
#include    <msviewinfo.fdf>
#include    <msvar.fdf>
#include    <dlmsys.fdf>
#include    <msdialog.fdf>

#include    <msrmgr.h>
#include    <mssystem.fdf>
#include    <msparse.fdf>

#include        <toolsubs.h>

//scan code
#include        <elementref.h>
//locate code
#include        <msdependency.fdf>
#include        <msassoc.fdf>
#include        <msmisc.fdf>
#include        <mslocate.fdf>
#include        <msstate.fdf>
#include        <msoutput.fdf>
#include    <msview.fdf>
#include <interface\INamedView.h>

//place command
#include        <mstmatrx.fdf>
char    *g_str;

#include "savedviewhelperCmd.h"
#include "savedviewhelper.h"
USING_NAMESPACE_BENTLEY
USING_NAMESPACE_BENTLEY_USTN

Public extern "C" StatusInt    mdlView_updateNamed
(
ViewInfoP           viewInfoP,
ViewPortInfoP       viewPortInfoP,
NamedViewProperties *propertiesP
);

/*---------------------------------------------------------------------------------**//**
* @bsimethod                                                    Mark.Anderson 11/07
+---------------+---------------+---------------+---------------+---------------+------*/
extern "C" void savedviewhelper_getExtent
    (
    char* name,
    double* x,
    double* y,
    double* z
    )
    {
    WString viewName (name);
    MSWCharCP nameP = viewName.c_str();
    INamedViewTraverseOptionsPtr options = INamedViewManager::CreateTraverseOptions (NULL,true,false);
    INamedViewPtr namedViewP = INamedViewManager::GetByName (*nameP,false,*options);
    ViewInfoCR viewInfo = namedViewP->GetViewInfoCR();
    DPoint3d pt = viewInfo.GetDelta();
    *x = pt.x;
    *y = pt.y;
    *z = pt.z;
    return;
    }
/*---------------------------------------------------------------------------------**//**
* @bsimethod                                                    Mark.Anderson 11/07
+---------------+---------------+---------------+---------------+---------------+------*/
extern "C" int savedviewhelper_setExtent 
    (
    char*     name,
    DPoint3dP extentsNew
    )
    {
    Bentley::WString viewName(name);
    MSWCharCP searchName = viewName.c_str();
    INamedViewTraverseOptionsPtr    options = INamedViewManager::CreateTraverseOptions (NULL, true, false);
    INamedViewPtr namedViewP = INamedViewManager::GetByName(*searchName,false,*options);
    ViewInfoR viewInfo = namedViewP->GetViewInfoR();
    /*DPoint3d originP = viewInfo.GetDelta();
    originP.x = extentsNew->x;
    originP.y = extentsNew->y;
    originP.z = extentsNew->z; */
    ViewGeomInfo geomInfoP = viewInfo.GetGeomInfo();
    geomInfoP.delta.x = extentsNew->x;
    geomInfoP.delta.y = extentsNew->y;
    geomInfoP.delta.z = extentsNew->z;
    viewInfo.SetGeomInfo (geomInfoP);

    namedViewP->SetViewInfo (viewInfo);
    INamedViewManager::Replace (*namedViewP,searchName,ISessionMgr::GetActiveDgnFile());

    return SUCCESS;
    }
/*---------------------------------------------------------------------------------**//**
* @bsimethod                                                    Mark.Anderson 11/07
+---------------+---------------+---------------+---------------+---------------+------*/
extern "C" void savedviewhelper_getOrigin
    (
    char* name,
    double* x,
    double* y,
    double* z
    )
    {
    WString viewName(name);
    MSWCharCP viewNameP = viewName.c_str();
    INamedViewTraverseOptionsPtr options = INamedViewManager::CreateTraverseOptions(NULL,true,false);
    INamedViewPtr namedViewP = INamedViewManager::GetByName(*viewNameP,false,*options);
    ViewInfoCR viewinfoR = namedViewP->GetViewInfoCR ();
    DPoint3d pt = viewinfoR.GetOrigin();
    *x = pt.x;
    *y = pt.y;
    *z = pt.z;
    return;
    }
/*---------------------------------------------------------------------------------**//**
* @bsimethod                                                    Mark.Anderson 11/07
+---------------+---------------+---------------+---------------+---------------+------*/
extern "C" int savedviewhelper_setOrigin
    (
    char*     name,
    DPoint3dP originNew
    )
    {
    WString viewName(name);
    INamedViewTraverseOptionsPtr options = INamedViewManager::CreateTraverseOptions(NULL,true,false);
    MSWCharCP searchName = viewName.c_str();
    INamedViewPtr namedViewP = INamedViewManager::GetByName(*searchName,false,*options);
    ViewInfoR viewInfo = namedViewP->GetViewInfoR();
    ViewPortInfoR viewPortP = namedViewP->GetViewPortInfoR();
    ViewGeomInfo geomInfoP = viewInfo.GetGeomInfo();
    geomInfoP.origin.x = originNew->x;
    geomInfoP.origin.y = originNew->y;
    geomInfoP.origin.z = originNew->z;
    viewInfo.SetGeomInfo (geomInfoP);
    namedViewP->SetViewInfo (viewInfo);
    INamedViewManager::Replace (*namedViewP,searchName,ISessionMgr::GetActiveDgnFile());

    return SUCCESS;
    }
/*---------------------------------------------------------------------------------**//**
* @bsimethod                                                    Mark.Anderson 11/07
+---------------+---------------+---------------+---------------+---------------+------*/
extern "C" int savedviewhelper_setCameraSettings
(
char* nameP,
DPoint3dP  position,
double*    angle,
double*    focalLength
)
{
WString viewName(nameP);
    MSWCharCP viewNameP = viewName.c_str();
    INamedViewTraverseOptionsPtr options = INamedViewManager::CreateTraverseOptions(NULL,true,false);
    INamedViewPtr namedViewP= NULL;
        namedViewP = INamedViewManager::GetByName(*viewNameP,false,*options); 
        if (namedViewP.get())
            {
            ViewInfoR viewInfo = namedViewP->GetViewInfoR();
            ViewGeomInfo geomInfoP = viewInfo.GetGeomInfo();
            geomInfoP.camera.position.x = position->x;
            geomInfoP.camera.position.y = position->y;
            geomInfoP.camera.position.z = position->z;
            geomInfoP.camera.angle = *angle;
            geomInfoP.camera.focalLength = *focalLength;
            viewInfo.SetGeomInfo (geomInfoP);
            namedViewP->SetViewInfo (viewInfo);
            INamedViewManager::Replace (*namedViewP,viewNameP,ISessionMgr::GetActiveDgnFile());

            return  SUCCESS;
            }
return  !SUCCESS;
   
}
/*---------------------------------------------------------------------------------**//**
* @bsimethod                                                    Mark.Anderson 11/07
+---------------+---------------+---------------+---------------+---------------+------*/
extern "C" int savedviewhelper_getCameraSettings
(
char* nameP,
DPoint3dP position,
double*   angle,
double*   focalLength
)
{
WString viewName(nameP);
MSWCharCP viewNameP = viewName.c_str();
INamedViewTraverseOptionsPtr options = INamedViewManager::CreateTraverseOptions(NULL,true,false);
INamedViewPtr namedViewP= NULL;
    namedViewP = INamedViewManager::GetByName(*viewNameP,false,*options);
    if (namedViewP.get())
        {
        CameraInfo pCamera;
        ViewInfoR viewInfo = namedViewP->GetViewInfoR();
        pCamera = viewInfo.GetCamera();
        position->x = pCamera.position.x;
        position->y = pCamera.position.y;
        position->z = pCamera.position.z;
        *angle = pCamera.angle;
        *focalLength = pCamera.focalLength;
        return  SUCCESS;
        }
return  !SUCCESS;
}
/*---------------------------------------------------------------------------------**//**
* @bsimethod                                                    Mark.Anderson 11/07
+---------------+---------------+---------------+---------------+---------------+------*/
extern "C" void savedviewhelper_setRotation2D
    (
    char* nameP,
    double angleRad
    )
{
    WString viewName(nameP);
    MSWCharCP wViewNameP = viewName.c_str();

    INamedViewTraverseOptionsPtr options = INamedViewManager::CreateTraverseOptions(NULL,true,false);
    INamedViewPtr namedViewP= NULL;
    namedViewP = INamedViewManager::GetByName(*wViewNameP,false,*options);
    if (namedViewP.get())
    {
        RotMatrix rMatrix;
        mdlRMatrix_getIdentity (&rMatrix);
        mdlRMatrix_fromAngle (&rMatrix,angleRad);
        ViewInfoR viewInfo = namedViewP->GetViewInfoR();
        ViewGeomInfo geomInfoP = viewInfo.GetGeomInfo();
        geomInfoP.rotation = rMatrix;
    }
return;
}
/*---------------------------------------------------------------------------------**//**
* @bsimethod                                                    Mark.Anderson 11/07
+---------------+---------------+---------------+---------------+---------------+------*/
extern "C" void savedviewhelper_getRotation2D 
    (
    char* nameP,
    double* angleRad
    )
{
    WString viewName(nameP);
    MSWCharCP wViewNameP = viewName.c_str();
    INamedViewTraverseOptionsPtr options = INamedViewManager::CreateTraverseOptions(NULL,true,false);
    INamedViewPtr namedViewP= NULL;
    namedViewP = INamedViewManager::GetByName(*wViewNameP,false,*options);
    if (namedViewP.get())
    {
        RotMatrixCR rMatrixCR = namedViewP->GetViewInfoCR().GetRotation();
        *angleRad = mdlRMatrix_toAngle (&rMatrixCR);
    }
return;
}
/*---------------------------------------------------------------------------------**//**
* @bsimethod                                                    Mark.Anderson 11/07
+---------------+---------------+---------------+---------------+---------------+------*/
extern "C" void savedviewhelper_setRotation3D
    (
    char* nameP,
    RotMatrixP inMatrixP
    )
{
    WString viewName(nameP);
    MSWCharCP wViewNameP = viewName.c_str();
    INamedViewTraverseOptionsPtr options = INamedViewManager::CreateTraverseOptions(NULL,true,false);
    INamedViewPtr namedViewP= NULL;
    namedViewP = INamedViewManager::GetByName(*wViewNameP,false,*options);
    if (namedViewP.get())
    {
        ViewInfoR viewInfo = namedViewP->GetViewInfoR();
        ViewGeomInfo geomInfoP = viewInfo.GetGeomInfo();
        geomInfoP.rotation = *inMatrixP;
    }
return;
}
/*---------------------------------------------------------------------------------**//**
* @bsimethod                                                    Mark.Anderson 11/07
+---------------+---------------+---------------+---------------+---------------+------*/
extern "C" void savedviewhelper_getRotation3D 
    (
    char* nameP,
    RotMatrixP outMatrixP
    )
{
    WString viewName(nameP);
    MSWCharCP wViewNameP = viewName.c_str();
    INamedViewTraverseOptionsPtr options = INamedViewManager::CreateTraverseOptions(NULL,true,false);
    INamedViewPtr namedViewP= NULL;
    namedViewP = INamedViewManager::GetByName(*wViewNameP,false,*options);
    if (namedViewP.get())
    {
         *outMatrixP = namedViewP->GetViewInfoCR().GetRotation();
    }
return;
}
/*---------------------------------------------------------------------------------**//**
* @bsimethod                                                    Mark.Anderson 11/07
+---------------+---------------+---------------+---------------+---------------+------*/
extern "C" void savedviewhelper_getClippingInfo
    (
    char*  viewNameP
    )
{
    WString viewName(viewNameP);
    MSWCharCP wViewNameP = viewName.c_str();
    INamedViewTraverseOptionsPtr options = INamedViewManager::CreateTraverseOptions(NULL,true,false);
    INamedViewPtr namedViewP= NULL;
    namedViewP = INamedViewManager::GetByName(*wViewNameP,false,*options);
    if (namedViewP.get())
    {
        
    }
}
/*---------------------------------------------------------------------------------**//**
* @bsimethod                                                    Mark.Anderson 11/07
+---------------+---------------+---------------+---------------+---------------+------*/
extern "C" int savedviewhepler_exists (char* name)
{
    WString viewName(name);
    MSWCharCP viewNameP = viewName.c_str();
    INamedViewTraverseOptionsPtr options = INamedViewManager::CreateTraverseOptions(NULL,true,false);
    INamedViewPtr namedViewP= NULL;
    namedViewP = INamedViewManager::GetByName(*viewNameP,false,*options);
        if (NULL == namedViewP.get())
                return 1;
        else
                return 0;
}
/*---------------------------------------------------------------------------------**//**
* @bsiclass                                                    Mark.Anderson 11/07
+---------------+---------------+---------------+---------------+---------------+------*/

struct _MyTraverseHandler:Bentley::Ustn::INamedViewTraverseHandler
    {
/*---------------------------------------------------------------------------------**//**
* @bsimethod                                                    Mark.Anderson 11/07
+---------------+---------------+---------------+---------------+---------------+------*/

    INamedViewTraverseOptionsPtr GetNamedViewTraverseOptions ()
        {
        return  INamedViewManager::CreateTraverseOptions(ISessionMgr::GetActiveDgnFile(),TRUE,FALSE);
        }
/*---------------------------------------------------------------------------------**//**
* @bsimethod                                                    Mark.Anderson 11/07
+---------------+---------------+---------------+---------------+---------------+------*/
    bool HandleNamedViewTraverse (INamedViewPtr pNamedView)
        {
        double x,y,z;
        char name[512];
        pNamedView->GetNameCP()->ToChar(name,512);
        savedviewhelper_getOrigin (name,&x,&y,&z);
        printf ("Found named view %s \n",name);
        return  FALSE;
        }
    };
static _MyTraverseHandler s_myTraverseHandler;

extern "C" DLLEXPORT void savedviewhelper_dumpNamedViews
(
char* unparsedP
)
    {
    INamedViewManager::Traverse (s_myTraverseHandler);
    }
/*---------------------------------------------------------------------------------**//**
* @description  savedviewhelper_mdlCommand
* @param        unparsed      The unparsed information sent to the command
* @bsimethod                                                    BSI             06/03
+---------------+---------------+---------------+---------------+---------------+------*/
extern "C" DLLEXPORT void savedviewhelper_mdlCommand 
(
char * unparsed
)
    {
    printf ("savedviewhelper_mdlCommand\n");
    double x;
    double y;
    double z;
    char* viewName ="Viewport";
        
    if (savedviewhepler_exists (viewName)>0)
        {
        savedviewhelper_dumpNamedViews("");
        return;
        }

    savedviewhelper_getOrigin (viewName,&x,&y,&z);
    printf("found %ld, %ld \n",x,y);
    savedviewhelper_getExtent(viewName,&x,&y, &z);
    printf ("extents %ld, %ld,  %ld \n",x,y,z); 

    mdlDialog_dmsgsPrint("savedviewhelper_mdlCommand\n");  

    }
/*---------------------------------------------------------------------------------**//**
* @description  MdlMain
* @param        argc      The number of command line parameters sent to the application.
* @param        argv[]    The array of strings sent to the application on the command line.
* @bsimethod                                                    BSI             06/03
+---------------+---------------+---------------+---------------+---------------+------*/
extern "C" DLLEXPORT  int MdlMain
(
int         argc,
char        *argv[]
)
    {
        RscFileHandle   rfHandle;
    SymbolSet* setP;

    mdlResource_openFile (&rfHandle,NULL,RSC_READONLY);
    setP = mdlCExpression_initializeSet (VISIBILITY_DIALOG_BOX,0,FALSE);
    mdlCExpression_publishFunction (setP,"savedviewhelper_getOrigin","PPPP",mdlCExpression_getType (TYPECODE_VOID),savedviewhelper_getOrigin);
    mdlCExpression_publishFunction (setP,"savedviewhelper_getExtent","PPPP",mdlCExpression_getType (TYPECODE_VOID),savedviewhelper_getExtent);
    
    mdlCExpression_publishFunction (setP,"savedviewhelper_setOrigin","PP",mdlCExpression_getType (TYPECODE_INT),savedviewhelper_setOrigin);
    mdlCExpression_publishFunction (setP,"savedviewhelper_setExtent","PP",mdlCExpression_getType (TYPECODE_INT),savedviewhelper_setExtent);

    mdlCExpression_publishFunction (setP,"savedviewhelper_getCameraSettings","PPPP",mdlCExpression_getType (TYPECODE_INT),savedviewhelper_getCameraSettings);
    mdlCExpression_publishFunction (setP,"savedviewhelper_setCameraSettings","PPPP",mdlCExpression_getType (TYPECODE_INT),savedviewhelper_setCameraSettings);
    
    mdlCExpression_publishFunction (setP,"savedviewhelper_setRotation2D","PD",mdlCExpression_getType (TYPECODE_VOID),savedviewhelper_setRotation2D);
    mdlCExpression_publishFunction (setP,"savedviewhelper_getRotation2D","PP",mdlCExpression_getType (TYPECODE_VOID),savedviewhelper_getRotation2D);

    mdlCExpression_publishFunction (setP,"savedviewhelper_setRotation3D","PP",mdlCExpression_getType (TYPECODE_VOID),savedviewhelper_setRotation3D);
    mdlCExpression_publishFunction (setP,"savedviewhelper_getRotation3D","PP",mdlCExpression_getType (TYPECODE_VOID),savedviewhelper_getRotation3D);

    mdlCExpression_publishFunction (setP,"savedviewhepler_exists","P",mdlCExpression_getType (TYPECODE_INT),savedviewhepler_exists);


    // Map command name to function (usage: MDL COMMAND COMPEXPORT)
    static  MdlCommandName cmdNames[] = 
    {
        {savedviewhelper_mdlCommand, "savedviewhelper_mdlCommand"  },
		{savedviewhelper_dumpNamedViews, "savedviewhelper_dumpNamedViews"},
        0,
    };

    mdlSystem_registerCommandNames (cmdNames);

    // Map key-in to function
    static MdlCommandNumber cmdNumbers[] =
    {
                {savedviewhelper_mdlCommand,  CMD_SAVEDVIEWHELPER_ACTION_DIALOG },
				{savedviewhelper_dumpNamedViews, CMD_SAVEDVIEWHELPER_ACTION_DUMP },
        0,
    };

    mdlSystem_registerCommandNumbers (cmdNumbers);

    mdlParse_loadCommandTable (NULL);

        return SUCCESS;
    }
